POJ 1745 Divisibility (线性dp)

简介:
Divisibility
Time Limit: 1000MS   Memory Limit: 10000K
Total Submissions:10598   Accepted: 3787

Description

Consider an arbitrary sequence of integers. One can place + or - operators between integers in the sequence, thus deriving different arithmetical expressions that evaluate to different values. Let us, for example, take the sequence: 17, 5, -21, 15. There are eight possible expressions: 17 + 5 + -21 + 15 = 16 
17 + 5 + -21 - 15 = -14 
17 + 5 - -21 + 15 = 58 
17 + 5 - -21 - 15 = 28 
17 - 5 + -21 + 15 = 6 
17 - 5 + -21 - 15 = -24 
17 - 5 - -21 + 15 = 48 
17 - 5 - -21 - 15 = 18 
We call the sequence of integers divisible by K if + or - operators can be placed between integers in the sequence in such way that resulting value is divisible by K. In the above example, the sequence is divisible by 7 (17+5+-21-15=-14) but is not divisible by 5. 

You are to write a program that will determine divisibility of sequence of integers. 

Input

The first line of the input file contains two integers, N and K (1 <= N <= 10000, 2 <= K <= 100) separated by a space. 
The second line contains a sequence of N integers separated by spaces. Each integer is not greater than 10000 by it's absolute value. 

Output

Write to the output file the word "Divisible" if given sequence of integers is divisible by K or "Not divisible" if it's not.

Sample Input

4 7
17 5 -21 15

Sample Output

Divisible

Source

Northeastern Europe 1999

题目链接:http://poj.org/problem?id=1745

题目大意:给n个数,让他们通过加减运算。推断结果可不可能被k整除

题目分析:用dp[i][j]表示通过前i个数的运算得到的余数为j可不可能。先看求a % k。假设a > k,则a = n * k + b。(n * k + b) % k == 0 + b % k = a % k,所以当a > k时,对求余数有影响的部分是不能被整除的部分。因此对于每一个数我们能够做a[i] = a[i] > 0 ? (a[i] % k) : -(a[i] % k)的预处理,然后就是在dp[i - 1][j]的情况下。推出下一状态。下一状态有两种可能,加和减,减的时候防止出现负数加上个k再取余,初始化dp[0][a[0]] = true最后仅仅要推断dp[n - 1][0]及前n个数通过加减运算是否能得到被k整除的值


#include <cstdio>
#include <cstring>
int const MAX = 10005;

bool dp[MAX][105];
int a[MAX];

int main()
{
    int n, k;
    while(scanf("%d %d", &n, &k) != EOF)
    {
        memset(dp, false, sizeof(dp));
        for(int i = 0; i < n; i++)
        {
            scanf("%d", &a[i]);
            a[i] = a[i] > 0 ? (a[i] % k) : -(a[i] % k);
        }
        dp[0][a[0]] = true;
        for(int i = 1; i < n; i++)
        {
            for(int j = 0; j <= k; j++)
            {
                if(dp[i - 1][j])
                {
                    dp[i][(j + a[i]) % k] = true;
                    dp[i][(k + j - a[i]) % k] = true;
                }
            }
        }
        printf("%s\n", dp[n - 1][0] ? "Divisible" : "Not divisible");
    }
}


版权声明:本文博客原创文章,博客,未经同意,不得转载。






本文转自mfrbuaa博客园博客,原文链接:http://www.cnblogs.com/mfrbuaa/p/4749832.html,如需转载请自行联系原作者


相关文章
|
19天前
acwing 275 传纸条 (线性dp)
acwing 275 传纸条 (线性dp)
12 0
|
19天前
|
人工智能
AcWing 274. 移动服务(线性dp)
AcWing 274. 移动服务(线性dp)
13 0
poj 1185 炮兵阵地 (状态压缩dp)
如果你是刚刚开始做状态压缩dp,我建议你先看看 poj 3254 Corn Fields 这是一道比这一题更简单,更容易入门的题目。 还有在代码中我用了一个很巧妙的方法求一个数二进制数中1的个数 具体请看我博客中 x& (x - 1)==0 这篇文章 链接 。
39 1
POJ-2253,Frogger(最短路问题)
POJ-2253,Frogger(最短路问题)
|
Java 测试技术
HDU 1248 寒冰王座(完全背包裸题)
寒冰王座 Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 17092    Accepted Submission(s): 8800 ...
1213 0
poj Dollar Dayz(完全背包)
点击打开链接poj 3181 思路: 完全背包+高精度 分析: 1 题目是裸的完全背包,但是要注意的一个地方是要用高精度 代码: #include #include #include #include using namespa...
974 0